<?php
namespace Bushelpowered\Api\Fulfillment\Threshold\V1\Response;
        
class ThresholdDetailResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $commodityCode;
    public string $locationId;
    public string $remarkCode;
    public ?float $minValue = null;
    public ?float $maxValue = null;
    /** @var \Bushelpowered\Api\Fulfillment\Recipient\V1\Response\RecipientResponse[] $recipients */
    public array $recipients;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  \Bushelpowered\Api\Fulfillment\Recipient\V1\Response\RecipientResponse[]  $recipients 
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $commodityCode, string $locationId, string $remarkCode, ?float $minValue, ?float $maxValue, array $recipients, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->commodityCode = $commodityCode;
        $this->locationId = $locationId;
        $this->remarkCode = $remarkCode;
        $this->minValue = $minValue;
        $this->maxValue = $maxValue;
        $this->recipients = $recipients;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}