<?php
namespace Bushelpowered\Api\Grain\Contracts\Event;
        
class PricingHistoryRawEvent implements \Bushelpowered\Api\Common\Event\Event, \Bushelpowered\Api\Common\Event\RawEvent
{
    public ?\Bushelpowered\Api\Grain\Contracts\Event\PricingHistoryRawVersions $raw = null;
    public string $idempotencyKey;
    /** @var string $eventCreationTime of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $eventCreationTime;
    public ?string $tenantId = null;
    public ?string $deleteIntegrationId = null;

    /**
     * @param  string  $eventCreationTime of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(?\Bushelpowered\Api\Grain\Contracts\Event\PricingHistoryRawVersions $raw, string $idempotencyKey, string $eventCreationTime, ?string $tenantId, ?string $deleteIntegrationId)
    {
        $this->raw = $raw;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
        $this->deleteIntegrationId = $deleteIntegrationId;
    }
    
    public function getRaw(): ?\Bushelpowered\Api\Grain\Contracts\Event\PricingHistoryRawVersions
    {
        return $this->raw;
    }
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getEventCreationTime(): string
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
    public function getDeleteIntegrationId(): ?string
    {
        return $this->deleteIntegrationId;
    }
}