<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1\Request;
        
class CheckEntityRequest implements \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasConsistency, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasPermissions, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasEntity
{
    public ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency $consistency = null;
    /** @var string[] $permissions */
    public array $permissions;
    public \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Entity $entity;

    /**
     * @param  string[]  $permissions 
     */
    public function __construct(?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency $consistency, array $permissions, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Entity $entity)
    {
        $this->consistency = $consistency;
        $this->permissions = $permissions;
        $this->entity = $entity;
    }
    
    public function getConsistency(): ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Consistency
    {
        return $this->consistency;
    }
    /**
     * @return string[] 
     */
    public function getPermissions(): array
    {
        return $this->permissions;
    }
    public function getEntity(): \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\Entity
    {
        return $this->entity;
    }
}