<?php
namespace Bushelpowered\Api\Platform\Authorization\V1;

use \Bushelpowered\Api\Platform\Authorization\V1\Request\LinkUserIdentifiersRequest;
use \Bushelpowered\Api\Common\Response\EmptyResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\BadGateway;
use \Bidl\Php\Core\Builtins\UnknownError;

class LinkUserIdentifiers 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(LinkUserIdentifiersRequest $request, $headers): EmptyResponse | BadRequest | NotAuthenticated | BadGateway | UnknownError
    {
         return $this->client->call('api/platform/authorization/v1/LinkUserIdentifiers', $request, $this->getWrapper(), $headers);
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var EmptyResponse | BadRequest | NotAuthenticated | BadGateway | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.authorization.v1#LinkUserIdentifiersSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\Response\EmptyResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadGateway':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadGateway::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}